import { ImageTransform } from './transforms/imageTransformTypes';
export declare type AssetType = 'image' | 'video' | 'raw' | 'auto';
export declare type DeliveryType = 'upload' | 'fetch' | 'facebook' | 'twitter' | 'twitter_name' | 'gravatar';
export interface CloudinaryConfiguration {
    cloudName: string;
    assetType?: AssetType;
    deliveryType?: DeliveryType;
    secure?: boolean;
    cdnSubdomain?: string;
    cname?: string;
    imageTransformDefaults?: ImageTransform;
}
export interface ImageTransformOptions extends ImageTransform {
    transformations?: ImageTransform | ImageTransform[];
    assetType?: AssetType;
    deliveryType?: DeliveryType;
    version?: string | number;
}
declare const cloudinary: ({ cloudName, assetType: assetTypeDefault, deliveryType: deliveryTypeDefault, secure, cdnSubdomain, cname, imageTransformDefaults: defaultTransform, }: CloudinaryConfiguration) => (publicId: string, options?: ImageTransform[] | ImageTransformOptions | undefined) => string;
export default cloudinary;
