"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.includes = exports.startsWith = exports.shouldBeOneOf = exports.isNumber = exports.invariantImage = void 0;
var invariantFor = function (type) { return function (condition, parameter, value, message, source) {
    if (source === void 0) { source = '/transformation_reference'; }
    if (!condition) {
        value = typeof value === 'string' ? "'" + value + "'" : value;
        source = source ? "http://cloudinary.com/documentation" + source : null;
        throw new Error("Cloudinary " + type + ":: " + parameter + " " + message + ", received: " + value + (source ? " - see " + source : ''));
    }
}; };
exports.invariantImage = invariantFor('Image ');
var isNumber = function (value) {
    return typeof value === 'number' || !Number.isNaN(Number(value));
};
exports.isNumber = isNumber;
var shouldBeOneOf = function (possibleValues) {
    return "should be one of ['" + possibleValues.join("', '") + "']";
};
exports.shouldBeOneOf = shouldBeOneOf;
var startsWith = function (needle, haystack) { return haystack.indexOf(needle) === 0; };
exports.startsWith = startsWith;
var includes = function (needle, haystack) { return haystack.indexOf(needle) > -1; };
exports.includes = includes;
